//+------------------------------------------------------------------+
//|                                                     TimeHour.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
//#property copyright "Copyright  2008"
//#property link      ""

//Indikator TimeHour vykresluje lomenou linku, ktera si "pamatuje" uzaviraci cenu prvni minuty 
//kazde hodiny a/nebo pulhodiny (volitelne).
//Indikator je pouzitelny jen na kratsich TF (1m, 5m, 15m), na vyssich se linka lame kazdou svici.
//Linka se vykresluje pouze omezeny pocet svici, jelikoz nacita data z 1M grafu, ktery pro starsi
//data nemusi byt k dispozici (omezeni max. sloupcu v grafu). Pro 5M graf je to 1/5, 15M graf 1/15 atd.

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- indicator parameters
extern bool CeleHodiny=false;
extern bool PulHodiny=true;

//---- buffers
double TimeBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  SetIndexBuffer(0,TimeBuffer);
  SetIndexStyle(0,DRAW_LINE, 4, 1);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Time Hour                                                        |
//+------------------------------------------------------------------+
int start()
{
  int i,counted_bars=IndicatorCounted();
  datetime bartime;
  int minuta, M1bar;

//----
  if(counted_bars<0) return(0);
//---- initial zero
   TimeBuffer[Bars]=EMPTY_VALUE;
//----
  for(i=Bars-counted_bars; i>=0; i--)
  {
    if(i>=Bars) continue;
    bartime=iTime(NULL, Period(), i);
    minuta=TimeMinute(bartime);
    if ((CeleHodiny && minuta==0) || (PulHodiny && minuta==30))
    {
      M1bar=iBarShift(NULL, PERIOD_M1, bartime, true);
      if (M1bar!=-1) 
        TimeBuffer[i]=iOpen(NULL, PERIOD_M1, M1bar);
      else
        TimeBuffer[i]=EMPTY_VALUE;
    }
    else
      if (TimeBuffer[i+1]==EMPTY_VALUE)
        TimeBuffer[i]=EMPTY_VALUE;
      else
        TimeBuffer[i]=TimeBuffer[i+1];
  }

//----
   return(0);
  }
//+------------------------------------------------------------------+